package java.util.concurrent;

import java.util.Collection;
import java.util.Queue;

public interface BlockingQueue<E> extends Queue<E>
{
    public abstract boolean add(E p0);
    
    public abstract boolean offer(E p0);
    
    public abstract void put(E p0) throws InterruptedException;
    
    public abstract boolean offer(E p0, long p1, TimeUnit p2) throws InterruptedException;
    
    public abstract E take() throws InterruptedException;
    
    public abstract E poll(long p0, TimeUnit p1) throws InterruptedException;
    
    public abstract int remainingCapacity();
    
    public abstract boolean remove(Object p0);
    
    public abstract boolean contains(Object p0);
    
    public abstract int drainTo(Collection<? super E> p0);
    
    public abstract int drainTo(Collection<? super E> p0, int p1);
}
